mode(-1);

stacksize(20000000)
// specific part
libname='libevp'
libtitle='Effective Image and Video Processing toolbox for scilab ';
write(%io(2), libtitle);

libevp_path=get_absolute_file_path('loader.sce');

// loader libs
if MSDOS then
	exec(libevp_path+'win_libs\EVP_loader.sce');
else
	exec(SCI+'/libs/EVP_loader.sce');
end;

// load the library macros
// execstr(libname+'=lib(""'+libevp_path+'macros/'+'"")')
getf(libevp_path + 'macros/color_balance.sci');
getf(libevp_path + 'macros/mirror.sci');
getf(libevp_path + 'macros/reverse.sci');
getf(libevp_path + 'macros/bright.sci');
getf(libevp_path + 'macros/contrast.sci');
getf(libevp_path + 'macros/col2gray.sci');
getf(libevp_path + 'macros/exposal.sci');
getf(libevp_path + 'macros/imThreshold.sci');
getf(libevp_path + 'macros/paint.sci');
getf(libevp_path + 'macros/emboss.sci');
getf(libevp_path + 'macros/blur.sci');
getf(libevp_path + 'macros/mosaic.sci');
getf(libevp_path + 'macros/lap_sharp.sci');
getf(libevp_path + 'macros/gauss_sharp.sci');
getf(libevp_path + 'macros/resize.sci');
getf(libevp_path + 'macros/rotate_4.sci');
getf(libevp_path + 'macros/rotate.sci');

getf(libevp_path + 'macros/imshow.sci');

//add the help chapter
add_help_chapter('EVP',libevp_path+'/man');

// add demos to demos menu
global demolist;
demolist = [demolist; 'EVP', SCI+'/contrib/evp/demos/evp.dem'];

clear libname;
clear libtitle;

global count;
count = 0;


disp 'Finish loading EVP.'
