//   This file is part of Scilab Aurora 
//	( http://scilab-aurora.sourceforge.net/ )
//   Copyright (C) 2006  XMU Scilab Aurora Team
//   Authors: (Scilab Aurora Team)
//     Jiang Fengbin <jonbo@126.com>
//     Lin Chuanwen <fjjllcw695@163.com>
//     Xiao Wenqing <pblz.xm@gmail.com>
//     Yang Kaigui  <justforward.xm@gmil.com>
//     Zheng Jiemin 
//     Zhou Xiyue   <zxy_0725@163.com>
//     Lin Shuyang  <macroxmu@gmail.com>
//   This program is licensed under GPL License;
//


//----------------------About Rotate-------------------------
//The Rotate is a Scilab function.We can get an image rotated
//any angle.We complete it by a C inte-rface program rotate
//(srcmat1,srcmat2,srcmat3,angle,mw,nw,desmat1,desmat2,desmat3).
//srcmat1 is the first channel of the source image.srcmat2 is 
//the second.srcmat3 is the third.desmat have similarity with
// srcmat.mw&nw is the height&width of the destination image. 
//
//
// Author  zhou xi yue    Date  Aug  4,2006 to Aug 5,2006
 //

function pImg=Rotate_4(im,angle) 

		if type(im)~=17 then
   		error('Error arg type');
   end;
   [m,n,k]=size(im);
   x0=n/2;
   y0=m/2;

   b=3.1415926*angle/180;
   sinz=sin(b);
   cosz=cos(b);

   dx1=cosz*(-x0)+sinz*(y0);
   dy1=-sinz*(-x0)+cosz*(y0);
   dx2=cosz*x0+sinz*(y0);
   dy2=-sinz*x0+cosz*(y0);
   dx3=cosz*(-x0)+sinz*(-y0);
   dy3=-sinz*(-x0)+cosz*(-y0);
   dx4=cosz*x0+sinz*(-y0);
   dy4=-sinz*x0+cosz*(-y0);
   
   nw=int(max(abs(dx4-dx1),abs(dx2-dx3))+0.5);
   mw=int(max(abs(dy4-dy1),abs(dy2-dy3))+0.5);
  
   in=zeros(mw,nw,4);
   in=uint8(in);
   [A,B,C,D]=rotate_4(im(:,:,1),im(:,:,2),im(:,:,3),im(:,:,4),angle,mw,nw,in(:,:,1),in(:,:,2),in(:,:,3),in(:,:,4))
   in(:,:,1)=A;
   in(:,:,2)=B;
   in(:,:,3)=C;
   in(:,:,4)=D;
   pImg=uint8(in);
   
 