//   This file is part of Scilab Aurora 
//	( http://scilab-aurora.sourceforge.net/ )
//   Copyright (C) 2006  XMU Scilab Aurora Team
//   Authors: (Scilab Aurora Team)
//     Jiang Fengbin <jonbo@126.com>
//     Lin Chuanwen <fjjllcw695@163.com>
//     Xiao Wenqing <pblz.xm@gmail.com>
//     Yang Kaigui  <justforward.xm@gmil.com>
//     Zheng Jiemin 
//     Zhou Xiyue   <zxy_0725@163.com>
//     Lin Shuyang  <macroxmu@gmail.com>
//   This program is licensed under GPL License;
//


/*-----------------------Aabout int_rotate-----------------
 *This is a C interface routine for Scilab. We can get an 
 *image  rotated any angle by this function.There are 9 
 *input variables.The first three variables are the three
 *channel matrixs of an source image.The fourth&fifth are 
 *the height and width of destination image.The last three 
 *variables are the three destination  matrixs,we don't need 
 *to malloc some memory space for the destination matrixs.
 *In addtion,thers is three output variable,they are the 
 *destination matrixs.  
 *----------------------------------------------------------*/
/*
 * Author  zhou xi yue    Date  Aug  4,2006 to Aug 5,2006
 */
#include "stack-c.h"
#include <stdlib.h>
#include <stdio.h>
#include "string.h"

int int_rotate_4(char *fname)
{

	
	 static int l1,m1,n1,l2,m2,n2,l3,m3,n3,l4,m4,n4,l5,m5,n5;
	 static int  minlhs=4, maxlhs=4,minrhs=11,maxrhs=11;

	 double  x0,y0,b;
   double  dx1,dy1,dx2,dy2,dx3,dy3,dx4,dy4;
   double  sinz,cosz;
   double  num1,num2;
   int     mw,nw;
   int     i,j,k,x,y;
   

	SciIntMat IntMat1;
	SciIntMat IntMat2;
	SciIntMat IntMat3;
	SciIntMat IntMat4;
	SciIntMat RetMat1;
  SciIntMat RetMat2;
  SciIntMat RetMat3;
  SciIntMat RetMat4;
	CheckRhs(minrhs,maxrhs);
	CheckLhs(minlhs,maxlhs);
	GetRhsVar(1,"I",&m1,&n1,&IntMat1);
	GetRhsVar(2,"I",&m1,&n1,&IntMat2);
	GetRhsVar(3,"I",&m1,&n1,&IntMat3);
	GetRhsVar(4,"I",&m1,&n1,&IntMat4);
	GetRhsVar(5,"d",&m2,&n2,&l2);
	GetRhsVar(6,"d",&m3,&n3,&l3);
	GetRhsVar(7,"d",&m4,&n4,&l4);
	GetRhsVar(8,"I",&m5,&n5,&RetMat1);
	GetRhsVar(9,"I",&m5,&n5,&RetMat2);
	GetRhsVar(10,"I",&m5,&n5,&RetMat3);	
	GetRhsVar(11,"I",&m5,&n5,&RetMat4);	
	RetMat1.m = IntMat1.m;
	RetMat1.n = IntMat1.n;
	RetMat1.it = IntMat1.it;
	RetMat1.l = -1;IntMat1.l;
//	RetMat1.D = malloc(sizeof(int)*(RetMat1.m*RetMat1.n));
		RetMat2.m = IntMat2.m;
	RetMat2.n = IntMat1.n;
	RetMat2.it = IntMat1.it;
	RetMat2.l = -1;IntMat1.l;
	//RetMat2.D = malloc(sizeof(int)*(RetMat2.m*RetMat2.n));
		RetMat3.m = IntMat3.m;
	RetMat3.n = IntMat1.n;
	RetMat3.it = IntMat1.it;
	RetMat3.l = -1;IntMat1.l;
	RetMat4.m = IntMat3.m;
	RetMat4.n = IntMat1.n;
	RetMat4.it = IntMat1.it;
	RetMat4.l = -1;IntMat1.l;
	//RetMat3.D = malloc(sizeof(int)*(RetMat3.m*RetMat3.n));

  x0=n1/2;
  y0=m1/2;
  b=3.1415926*(stk(l2)[0])/180;
  sinz=sin(b);
  cosz=cos(b);
  mw=stk(l3)[0];
  nw=stk(l4)[0];
   	
  num1=-0.5*nw*cosz-0.5*mw*sinz+0.5*n1;
  num2=0.5*nw*sinz-0.5*mw*cosz+0.5*m1;

  for(i=0;i<mw;i++)
    for(j=0;j<nw;j++)
       {
         x=(int)(j*cosz+i*sinz+num1);
         y=(int)(num2-j*sinz+i*cosz);
		    if(x>=0&&x<n1&&y>=0&&y<m1)
          {
          	((unsigned char*)(RetMat1.D))[i+j*mw] = ((unsigned char*)(IntMat1.D))[y+x*m1];
          	((unsigned char*)(RetMat2.D))[i+j*mw] = ((unsigned char*)(IntMat2.D))[y+x*m1];
          	((unsigned char*)(RetMat3.D))[i+j*mw] = ((unsigned char*)(IntMat3.D))[y+x*m1];
          	((unsigned char*)(RetMat4.D))[i+j*mw] = ((unsigned char*)(IntMat4.D))[y+x*m1];
           }
		   }
 
  RetMat1.m=mw;
  RetMat1.n=nw;
  RetMat2.m=mw;
  RetMat2.n=nw;
  RetMat3.m=mw;
  RetMat3.n=nw;
   RetMat4.m=mw;
  RetMat4.n=nw;
	CreateVarFromPtr(8,"I",&(RetMat1.m), &(RetMat1.n), &RetMat1 ); 
  CreateVarFromPtr(9,"I",&(RetMat2.m), &(RetMat2.n), &RetMat2 );
  CreateVarFromPtr(10,"I",&(RetMat3.m), &(RetMat3.n), &RetMat3 );
  CreateVarFromPtr(11,"I",&(RetMat4.m), &(RetMat4.n), &RetMat4 );
	
	LhsVar(1)=8;
	LhsVar(2)=9;
	LhsVar(3)=10;
	LhsVar(4)=11;
  return 0;
}

